// naumann@stce.rwth-aachen.de

#include "f.hpp"

#include "dco.hpp"

#include <vector>

template<typename T, typename PT>
void hessian(size_t ncp, size_t ncs, const PT &eps, T &x_v, const std::vector<T> &p_v, const std::vector<std::vector<PT>> &dW, std::vector<T> &dxdp, std::vector<std::vector<T>> &ddxdpp) {
  using DCO_BT=typename dco::gt1s<T>::type;
  using DCO_M=typename dco::ga1s<DCO_BT>;
  using DCO_T=typename DCO_M::type;
  using DCO_TT=typename DCO_M::tape_t;
  using DCO_TPT=typename DCO_TT::position_t;
  size_t n=p_v.size();
  DCO_T x; std::vector<DCO_T> p(n); dco::passive_value(p)=p_v;
  DCO_M::global_tape=DCO_TT::create();
  DCO_M::global_tape->register_variable(p);
  DCO_TPT tpos=DCO_M::global_tape->get_position();
  for (size_t i=0;i<n;i++) {
    dco::derivative(dco::value(p[i]))=1;
    x=x_v;
    f(ncp,ncs,eps,x,p,dW);
    dco::value(dco::derivative(x))=1;
    DCO_M::global_tape->interpret_adjoint_and_reset_to(tpos);
    for (size_t j=0;j<n;j++) {
      ddxdpp[i][j]=dco::derivative(dco::derivative(p[j]));
      dco::derivative(dco::derivative(p[j]))=0;
      dco::value(dco::derivative(p[j]))=0;
    }
    dxdp[i]=dco::derivative(dco::value(x));
    dco::derivative(dco::value(p[i]))=0;
  }
  x_v=dco::passive_value(x);
  DCO_TT::remove(DCO_M::global_tape);
}

#include "h_main.hpp"
